<%@ Language=VBScript %>
<!-- #include file="sea500config.asp" -->
<!-- #include file="sea500mailsubs.asp" -->
<%
const langeval="Site Error Alert Evaluation Copy Version 1.10"
'****************************************************************************
' Site Error Alert _ evalution Copy
' This version does not include 
'   Mailing of trap data
'   File Logging
'   Contact Form
' Trap Windows http 500 Errors and then
'  a) Send email to site owner
'  b) Write Trace File
'  c) Write messages to browser
' Copyright: HK Programming
' Version 1.10
' October 3, 2006
' File sea500_config.asp determines functions to perform
'
' /iisHelp/common/500-100.asp     ' microsoft default version
'****************************************************************************
dim recordcount                 ' number of messages
dim msg                         ' mail and file message
dim writeinfo                   '   browser write = true
dim writebrowser                ' true or false
DoTrap                           ' do the actual  trap code

'****************************************************************************
' actual trap code
' First get default values from configuration file
' Create messages based on server object and error object
' send emails
' Write trace File
' Write to browser
'****************************************************************************
Sub Dotrap 
dim strdata, strmethod, errnumber
 InitializeProgram
msg=""
Set objASPError = Server.GetLastError
If writebrowser=true then
  Responsewrite "<tr><td colspan=2><b>" & "Error Details" & "</b></td></tr>"
end if  
trapwrite "Date and time",now()
trapwrite "Error Category", objASPError.Category
trapwrite "ASP Code",Server.htmlEncode(objASPError.ASPCode)
trapwrite "Brief Description", objASPError.Description
trapwrite "Long Description", objASPError.ASPDescription

trapwrite "File Name",objASPError.File
trapwrite "Line Number",objASPError.Line
trapwrite "Column",objASPError.Column
trapwrite "Source",objASPError.Source
trapwrite "URL",Request.ServerVariables("URL")
strMethod =Request.ServerVariables("REQUEST_METHOD")
strData = Request.QueryString() 
if strdata<>"" then
  trapwrite "Query string", strdata
end if  
if strMethod = "POST" then 
   strData = Request.Form() 
   if strdata<>"" then   
      trapwrite "Form Data", strdata 
   end if
end if  
If writebrowser=true then
  Responsewrite "<tr><td colspan=2><b>" & "Site Details" & "</b></td></tr>"
end if  

trapwrite "Server name",LCase(Request.ServerVariables("SERVER_NAME"))
trapwrite "Local IP Address ",Request.ServerVariables("LOCAL_ADDR")
Trapwrite "Remote IP", Request.ServerVariables("REMOTE_ADDR")
trapwrite "User Agent",Request.ServerVariables("HTTP_USER_AGENT") 
trapwrite "Method", Request.ServerVariables("REQUEST_METHOD")
errnumber=objASPError.Number
errnumber= "(0x" & Hex(errnumber) & ")" 
trapwrite "Error Number",errnumber
'
'   now we have the information write it to file, email it and write to browser

TrapWriteEmail   msg
TrapWritetoFile  msg 
'
' If displaying to browser close the table
' if writing to browser close table
If lcase(config_writebrowser)="yes" then
     responsewrite "</table>"
end if
' should we go somewhere else
if config_siteredirect<>"" and config_prompt="" then 
  response.redirect config_siteredirect
end if  
WritePromptForm                   ' see if we want customer details
WriteLinkToHkProg
Responsewrite "</center>"
responsewrite "</body></html>"
end sub

'*************************************************************************
' if we are redirecting, make sure we don't display on browser
sub InitializeProgram 
dim url
Response.Buffer = true
If Response.Buffer Then
    Response.Clear
    'Response.Status = "200 OK"
    Response.Status = "500 Internal Server Error"
    Response.ContentType = "text/html"
    Response.Expires = 0
End If

recordcount=0
msg=""
' Are we ultimately redirecting to another location?
If config_siteredirect<>"" and lcase(config_prompt)<>"yes"  then
   writeinfo=false
else
   writeinfo=true
end if
if lcase(config_writebrowser)="yes" then
   writebrowser=true
else
   writebrowser=false
end if      
'debugwrite "browser=" & writebrowser & "writeinfo=" & writeinfo
' Put out HTML Header as necessary
WriteHtmlHeader  
' Write browser headers    
responsewrite "<center>"
responsewrite "<h2>" & config_title & "<br>" & langeval & "</h2>"
responsewrite "<p align='center'>" & config_sitemessage 
' if generating a hyperlink, do it here
If config_sitehyperlink<>"" then 
   url="<a href='" & config_sitehyperlink & "'>" & "Continue" & "</a>"
   responsewrite "<br>" & url  & "<br>"
end if  
responsewrite "</p>"
' 
If writebrowser=true  then
     responsewrite "<table>" 
end if

end sub

'**********************************************************************
'Put data in msg variable and possibly write to browser
'**********************************************************************
Sub TrapWrite (caption,record)
dim output
Formatrecord  caption, record, output
If writebrowser=true  then
    Writetobrowser caption, record
end if  
msg=msg & output
recordcount=recordcount+1
end sub
'**********************************************************************
' record for mailing and write to file
'**********************************************************************
sub Formatrecord  (caption, record, output)
If record<>"" then
  output=caption & "=" & record  & vbcrlf
end if
end sub
'
'********************************************************************
' don't put out null records to browser
'********************************************************************
Sub WritetoBrowser (caption, record)
if record<>"" then
  responsewrite "<tr><td class=caption align=left>" & caption & "</td><td class=values>" &  record & "</td></tr>" 
end if
end sub
'********************************************************************************
' create file based on date and time
' write message
'*******************************************************************************
Sub TrapWritetoFile  (msg)
if lcase(config_writefile)<>"yes" then exit sub
if lcase(config_writefile)<>"yes" then exit sub
Response.write "<h3>" & "This is an Evalution copy of Site Error Alter<br>File Logging is not supported</h3>"
end sub


'********************************************************************************
' create file based on date and time
' write message
'*******************************************************************************
Sub TrapWriteEmail  (msg)
dim emaillist, emailarray, emailcount
if lcase(config_writeemail)<>"yes" then exit sub
if config_emailaddress="" then exit sub
emailarray=split(config_emailaddress,",")
emailcount=ubound(emailarray)+1
dim fromname, fromaddress, toname, toaddress, subject, body, imailtype
dim imailsystem, ihtmlformat, attachmentlist, mailerror
fromname=config_emailname      ' name from and to
fromaddress=emailarray(0)      'first email is from address
subject=config_emailsubject
body="Error data not supplied in evaluation version" & vbcrlf
imailtype=config_emaildriver
ihtmlformat="txt"
attachmentlist="" 
imailsystem=config_emailsystem
' use subroutine to write message
for i = 0 to emailcount-1
  toaddress=emailarray(i)              ' from list of addreses
  WritemailMessage fromname, fromaddress, toname, toaddress, subject, body, imailtype, imailsystem, ihtmlformat, attachmentlist, mailerror
next  
end sub
'**********************************************************************************
' if writing messages to browser then do it
'*********************************************************************************
function Responsewrite  (datamsg)
if writeinfo=false then exit function
response.write datamsg & vbcrlf
end function

'**********************************************************************************
' if we are writing data to browser then put out html header
'********************************************************************************

Sub WriteLinktoHkprog
 dim url
 dim site
 site="http://www.hkprog.com"
 url="<a href='" & site &  "'>" & "Powered by Site Error Alert" & "</a>"      
 responsewrite "<br>" & url  & "<br>"                                    
end sub

'***********************************************************************
' if we are prompting for customer details
'**********************************************************************
Sub WritePromptForm
dim fieldnames, fieldcount, i, caption, fieldname
dim installurl
If lcase(config_prompt)<>"yes" then exit sub
if config_promptfields="" then exit sub
writeinfo=true
if config_installurl<>"" then 
   installurl= config_installurl & "/"
else
   installurl=""
end if      
installurl=installurl  & "sea500contact.asp"
fieldnames=split(config_promptfields,",")
fieldcount=ubound(fieldnames)+1
responsewrite "<br><h3>" & config_promptmessage & "</h3>"
responsewrite "<form action='" & installurl & "' method='post' name='contact'>"
responsewrite "<table border=0 cellpadding=0 cellspacing=0>"
for i = 0 to fieldcount-1
  fieldname=replace(fieldnames(i)," ","")       ' remove blanks
  caption=replace(fieldname,"_"," ")        ' captions remove underscore    
  Responsewrite "<tr class=promptrow><td class=heading align='left'>" &  caption & "</td>"
  responsewrite "<td class=values><input type='text' name='" & fieldname & "' size='40' value=''></td></tr>"
next
responsewrite "</table>"
responsewrite "<input type=submit name=Submit value='Submit'>"
responsewrite "</form>"
end sub

Sub WriteHTMLHeader
if writeinfo=false then exit sub
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<html>
<head>
<META NAME="ROBOTS" CONTENT="NOINDEX">
<title><%=config_title%></title>
<META HTTP-EQUIV="Content-Type" Content="text-html; charset=Windows-1252">
<style type='text/css'>
BODY  { FONT-FAMILY: Arial; FONT-SIZE: 10pt;
	   BACKGROUND: #ffffff; COLOR: #000000;
	   MARGIN: 15px; }
H2    { FONT-SIZE: 14pt; COLOR: #ff0000; }
H3    { FONT-SIZE: 10pt; COLOR: #47616f; }
TABLE { BACKGROUND: #000000; PADDING: 5px; }
TH    { BACKGROUND: #c0c0c0; COLOR: #000000; }
TR    { BACKGROUND: #ffffff; COLOR: #000000; }
TR.promptrow   { BACKGROUND: #eceff0; COLOR: #000000; }
TD.caption {FONT: 11px Verdana, Helvetica, sans-serif; COLOR: black; FONT-WEIGHT: bold; }
TD.values {FONT: 11px Verdana, Helvetica, sans-serif; COLOR: black; }
TD.prompt {FONT: 11px Verdana, Helvetica, sans-serif; COLOR: black; FONT-WEIGHT: bold; }
</style>
</head>
<BODY>
<%
end sub

%>

